#include <stdio.h>
#include <stdlib.h>
#include <pthread.h>

#define ARR_SIZE 100

static double arr[ARR_SIZE];
static int count;
static double firstSum;
static double secondSum;

//Define our thread function

void * FirstThread(void * threadId)
{
  int i = 0;
  firstSum = 0;

  for( i = 0 ; i < count/2; i++)
    firstSum += arr[i];
  pthread_exit(NULL); //Cause the thread to die.
}

void * SecondThread(void * threadId)
{
  int i = 0;
  secondSum = 0;

  for( i = count/2 ; i < count; i++)
    secondSum += arr[i];

  pthread_exit(NULL); //Cause the thread to die.
}

int main(int argc, char ** argv)
{
  pthread_t threadList[2];  //Declare a list of threads

  int return_code;

  long i;  //counter to keep track of the current thread identifier
  double x;
  count = 0;

  printf("Enter at most 100 doubles (one per line) terminated with a -1.\n");

  scanf("%lf", &x);
  while(x != -1)
  {
    arr[count] = x;
    scanf("%lf", &x);
    count++;
  }

  return_code = pthread_create(&threadList[0], NULL, FirstThread,
            (void *) 0);

  if(return_code != NULL)
  {
    printf("The return code from the first thread is %d\n", return_code);
    exit(-1);
  }

  return_code = pthread_create(&threadList[1], NULL, SecondThread,
            (void *) 1);

  if(return_code != NULL)
  {
    printf("The return code from the second thread is %d\n", return_code);
    exit(-1);
  }

  return_code = pthread_join(threadList[0], NULL);
  if(return_code != NULL)
  {
    printf("Unable to join even thread");
    exit(-1);
  }
  return_code = pthread_join(threadList[1], NULL);
  if(return_code != NULL)
  {
    printf("Unable to join odd thread");
    exit(-1);
  }

  double sum = secondSum+firstSum;

  printf("The total is %lf\n", sum);

  pthread_exit(NULL);

  return 0;
}
